
#include <pic.h>
#include "delay.h"
#include "lcd.h"

void Lcd_strobe(void)
{
LCD_EN=1;
//DelayUs(10);
LCD_EN=0;
}

void Lcd_write(unsigned char byte)
{
DelayUs(43);
LCD_DATA = ((byte>>4)&0x0F);
Lcd_strobe();
LCD_DATA = (byte&0x0F);
Lcd_strobe();
}

void Lcd_putch(unsigned char ch)
{
LCD_RS = 1;
Lcd_write(ch);
}

void Lcd_puts(const char *s)
{
LCD_RS = 1;
while(*s)
	Lcd_write(*s++);
}

void Lcd_clear(void)
{
LCD_RS = 0;
Lcd_write(0x01);
DelayMs(2);
}

void Lcd_ret_home(void)
{
LCD_RS = 0;
Lcd_write(0x02);
DelayMs(2);
}

void Lcd_goto_pos(unsigned char row, unsigned char position)
{
unsigned char pos;

LCD_RS = 0;
if(row == 1)
	pos = 0x00 | position;
if(row == 2)
	pos = 0x40 | position;
if(row == 3)
	pos = 0x10 | position;
if(row == 4)
	pos = 0x50 | position;
Lcd_write(0x80|pos);
}

void Lcd_init(void)
{
LCD_DATA_DIR = set_direction;
LCD_RS = LCD_EN = 0;
LCD_RS_DIR = LCD_EN_DIR = output;

DelayMs(15);
LCD_DATA = init_value;
Lcd_strobe();
DelayMs(5);
LCD_DATA = init_value;
Lcd_strobe();
DelayUs(200);
LCD_DATA = init_value;
Lcd_strobe();
LCD_DATA = 0x02;
Lcd_strobe();
Lcd_write(function_set);
Lcd_write(display_control);
Lcd_clear();
Lcd_write(entry_mode_set);
}




