
#ifndef _LCD_h_
#define _LCD_h_

// define LCD interface
#define LCD_DATA PORTB                  // DB0-DB7
#define LCD_DATA_DIR TRISB

#define LCD_RS RA1                      // RS pin
#define LCD_RS_DIR TRISA1

//#define LCD_RW xx                     //if R/W not connect to GND
//#define LCD_RW_DIR xx

#define LCD_EN RA0                      // EN pin
#define LCD_EN_DIR TRISA0

//#define LCD_BL xx                     //backlight on/off
//#define LCD_BL_DIR xx

// define display settings
#define function_set 0x28       /* 0 0 1 DL N F 0 0 */ 
                                // Function set
                                // bit2 set 0 - dot format 5x8
                                //          1 - dot format 5x11
                                // bit3 set 0 - 1 line mode
                                //          1 - 2 line mode
                                // bit4 set 0 - 4 bit mode
                                //          1 - 8 bit mode

//#define cur_disp_shift 0x??   /* 0 0 0 1 S/C R/L 0 0 */
                               // Cursor or display shift
                               // bit2 set 0 - shift left
                               //          1 - shift right
                               // bit3 set 0 - cursor shift
                               //          1 - display shift

#define display_control 0x0C    /* 0 0 0 0 1 D C B */
                                // Display control
                                // bit0 set 0 - blink OFF
                                //          1 - blink ON
                                // bit1 set 0 - cursor OFF
                                //          1 - cursor ON
                                // bit2 set 0 - display OFF
                                //          1 - display ON

#define entry_mode_set 0x06     /* 0 0 0 0 0 1 I/D SH */
                                // Entry mode set
                                // bit0 set 0 - entire shift OFF
                                //          1 - entire shift ON
                                // bit1 set 0 - decrement mode
                                //          1 - increment mode

// define other constants
#define output 0
#define init_value 0x03
#define set_direction 0xF0

// function prototypes
void Lcd_strobe(void);
void Lcd_write(unsigned char byte);
void Lcd_putch(unsigned char ch);
void Lcd_puts(const char *s);
void Lcd_clear(void);
void Lcd_ret_home(void);
void Lcd_goto_pos(unsigned char row, unsigned char pos);
void Lcd_init(void);

#endif